using System;
using System.ComponentModel;
using System.Drawing;
using System.IO;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using InfiniTec.Exchange;
using InfiniTec.Exchange.WebDav;
using InfiniTec.Exchange.WebDav.Request;
using InfiniTec.Threading;

namespace ExampleApplication.Example
{
    [View("Create item", "WebDAV low-level operations")]
    internal class CreateItem : ExampleBase
    {
        private Button btnCreate;
        private Label label2;
        private TextBox tbContent;
        private ListBox lbLog;

        private Stream _Stream;

        public CreateItem()
        {
            InitializeComponent();
        }

        private void InitializeComponent()
        {
            tbContent = new TextBox();
            btnCreate = new Button();
            label2 = new Label();
            lbLog = new ListBox();
            SuspendLayout();
            // 
            // tbContent
            // 
            tbContent.Anchor = ((AnchorStyles) ((((AnchorStyles.Top | AnchorStyles.Bottom)
                                                  | AnchorStyles.Left)
                                                 | AnchorStyles.Right)));
            tbContent.Location = new Point(11, 51);
            tbContent.Multiline = true;
            tbContent.Name = "tbContent";
            tbContent.ScrollBars = ScrollBars.Vertical;
            tbContent.Size = new Size(599, 161);
            tbContent.TabIndex = 2;
            // 
            // btnCreate
            // 
            btnCreate.Anchor = ((AnchorStyles) ((AnchorStyles.Bottom | AnchorStyles.Right)));
            btnCreate.Location = new Point(538, 218);
            btnCreate.Name = "btnCreate";
            btnCreate.Size = new Size(75, 23);
            btnCreate.TabIndex = 3;
            btnCreate.Text = "&Create";
            btnCreate.UseVisualStyleBackColor = true;
            btnCreate.Click += new EventHandler(btnCreate_Click);
            // 
            // label2
            // 
            label2.AutoSize = true;
            label2.Location = new Point(8, 35);
            label2.Name = "label2";
            label2.Size = new Size(47, 13);
            label2.TabIndex = 4;
            label2.Text = "Content:";
            // 
            // lbLog
            // 
            lbLog.Anchor = ((AnchorStyles) (((AnchorStyles.Bottom | AnchorStyles.Left)
                                             | AnchorStyles.Right)));
            lbLog.FormattingEnabled = true;
            lbLog.Location = new Point(11, 247);
            lbLog.Name = "lbLog";
            lbLog.Size = new Size(599, 95);
            lbLog.TabIndex = 5;
            // 
            // CreateItem
            // 
            AutoScaleDimensions = new SizeF(6F, 13F);
            Controls.Add(lbLog);
            Controls.Add(btnCreate);
            Controls.Add(label2);
            Controls.Add(tbContent);
            Name = "CreateItem";
            Size = new Size(613, 349);
            Controls.SetChildIndex(tbContent, 0);
            Controls.SetChildIndex(label2, 0);
            Controls.SetChildIndex(btnCreate, 0);
            Controls.SetChildIndex(lbLog, 0);
            ResumeLayout(false);
            PerformLayout();
        }

        private void btnCreate_Click(object sender, EventArgs e)
        {
            SimpleItem item;

            item = GetItem();
            item.SetContentProgressChanged += item_SetContentProgressChanged;
            item.SetContentCompleted += item_SetContentCompleted;

            _Stream = new MemoryStream(Encoding.UTF8.GetBytes(tbContent.Text));

            item.SetContentAsync(_Stream, WellknownContentTypes.OctetStream);
        }

        private void item_SetContentCompleted(object sender, AsyncCompletedEventArgs e)
        {
            _Stream = null;

            if (e.Error != null)
            {
                ViewManager.ShowException(e.Error);
                return;
            }

            lbLog.Items.Add("Finished. Cancelled: " + e.Cancelled);
        }

        private void item_SetContentProgressChanged(object sender, ProgressChangedEventArgs<RequestStatus> e)
        {
            lbLog.Items.Add(e.Status.ToString());
        }

        protected SimpleItem GetItem()
        {
            SimpleItem item = new SimpleItem(RootPath, ConnectionView.Connection);

            return item;
        }
    }
}