using System.Collections.Generic;

namespace InfiniTec.Exchange
{
    /// <summary>
    /// Extends the <see cref="IList&lt;T&gt;"/> interface with an additional indexer.
    /// </summary>
    /// <typeparam name="TKey">The key type of the collection</typeparam>
    /// <typeparam name="TValue">The value type of the collection</typeparam>
    public interface IKeyedCollection<TKey, TValue>: IList<TValue>
    {
        /// <summary>
        /// Gets the element at the specified index.
        /// </summary>
        /// <value></value>
        TValue this[TKey index] { get; }
    }
}
