using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Text;

namespace InfiniTec.Exchange
{
    /// <summary>
    /// Exception thrown when an invalid name was passed to a method.
    /// </summary>
    [Serializable]
    public sealed class InvalidNameException : ArgumentException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InvalidNameException"/> class.
        /// </summary>
        public InvalidNameException() {}
	
        /// <summary>
        /// Initializes a new instance of the <see cref="InvalidNameException"/> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public InvalidNameException(string message) : base(message) {}
		
        /// <summary>
        /// Initializes a new instance of the <see cref="InvalidNameException"/> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        public InvalidNameException(string message, Exception innerException) : base(message, innerException) {}
	
        /// <summary>
        /// Initializes a new instance of the <see cref="InvalidNameException"/> class.
        /// </summary>
        /// <param name="context">The <see cref="StreamingContext"/> to recreate the exception from.</param>
        /// <param name="info">The <see cref="SerializationInfo"/> to recreate the exception from.</param>
        private InvalidNameException(SerializationInfo info, StreamingContext context): base(info, context) {}
    }
}
