using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Text;

namespace InfiniTec.Exchange
{
    /// <summary>
    /// Exception thrown when the local free/busy folder cannot be found on the mailbox.
    /// </summary>
    [Serializable]
    public sealed class LocalFreeBusyInformationNotFoundException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="LocalFreeBusyInformationNotFoundException"/> class.
        /// </summary>
        public LocalFreeBusyInformationNotFoundException() {}
	
        /// <summary>
        /// Initializes a new instance of the <see cref="LocalFreeBusyInformationNotFoundException"/> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public LocalFreeBusyInformationNotFoundException(string message) : base(message) {}
		
        /// <summary>
        /// Initializes a new instance of the <see cref="LocalFreeBusyInformationNotFoundException"/> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        public LocalFreeBusyInformationNotFoundException(string message, Exception innerException) : base(message, innerException) {}
	
        /// <summary>
        /// Initializes a new instance of the <see cref="LocalFreeBusyInformationNotFoundException"/> class.
        /// </summary>
        /// <param name="context">The <see cref="StreamingContext"/> to recreate the exception from.</param>
        /// <param name="info">The <see cref="SerializationInfo"/> to recreate the exception from.</param>
        private LocalFreeBusyInformationNotFoundException(SerializationInfo info, StreamingContext context): base(info, context) {}
    }
}
