using System;
using System.Runtime.Serialization;
using InfiniTec.Exchange.WebDav.Request;

namespace InfiniTec.Exchange.WebDav
{
    /// <summary>
    /// Exception thrown when a WebDAV request failed.
    /// </summary>
    [Serializable]
    public sealed class RequestFailedException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RequestFailedException"/> class.
        /// </summary>
        public RequestFailedException() { }

        /// <summary>
        /// Initializes a new instance of the <see cref="RequestFailedException"/> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public RequestFailedException(string message) : base(message) { }

        /// <summary>
        /// Initializes a new instance of the <see cref="RequestFailedException"/> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        public RequestFailedException(string message, Exception innerException) : base(message, innerException) { }

        /// <summary>
        /// Initializes a new instance of the <see cref="RequestFailedException"/> class.
        /// </summary>
        /// <param name="context">The <see cref="StreamingContext"/> to recreate the exception from.</param>
        /// <param name="info">The <see cref="SerializationInfo"/> to recreate the exception from.</param>
        private RequestFailedException(SerializationInfo info, StreamingContext context) : base(info, context) { }
    }
}