using System;
using System.Collections.Generic;
using System.Text;

namespace InfiniTec.Exchange.WebDav
{
    /// <summary>
    /// Encapsulates a search result from <see cref="Methods.Search"/> operation
    /// </summary>
    public class SearchResult
    {
        private IList<SimpleItem> _Items;
        private int _TotalItems;


        /// <summary>
        /// Initializes a new instance of the <see cref="SearchResult"/> class.
        /// </summary>
        /// <param name="_Items">The items of the search operation.</param>
        /// <param name="_TotalItems">The number of total items.</param>
        public SearchResult(IList<SimpleItem> _Items, int _TotalItems)
        {
            this._Items = _Items;
            this._TotalItems = _TotalItems;
        }

        /// <summary>
        /// Gets the items of the search operation.
        /// </summary>
        /// <value>The items of the search operation.</value>
        public IList<SimpleItem> Items
        {
            get { return _Items; }
        }

        /// <summary>
        /// Gets the number of total items.
        /// </summary>
        /// <value>The number total items.</value>
        public int TotalItems
        {
            get { return _TotalItems; }
        }
    }
}
