using System;
using System.Collections.Generic;
using System.Text;

namespace InfiniTec.Exchange
{
    /// <summary>
    /// This class provides some constants for MIME content types
    /// </summary>
    public static class WellknownContentTypes
    {
        /// <summary>
        /// The content type of a standard email message
        /// </summary>
        public const string MailMessage = "message/rfc822";
        /// <summary>
        /// The content type of a binary stream
        /// </summary>
        public const string OctetStream = "application/octet-stream";
        /// <summary>
        /// The content type of an xml document
        /// </summary>
        public const string Xml = "text/xml";
        /// <summary>
        /// the content type of a plain text
        /// </summary>
        public const string Plaintext = "text/plain";
    }
}
